SAVECORE(8) | System Manager's Manual | SAVECORE(8)

# NAME

`savecore` —
save a core dump of the operating system

# SYNOPSIS

`savecore` | [`-fvz`] [`-N` system] [`-Z` level] [directory]

`savecore` | `-c` [`-v`] [`-N` system]

`savecore` | `-n` [`-v`] [`-N` system]

# DESCRIPTION

When the NetBSD kernel encounters a fatal error, the panic(9) routine arranges for a snapshot of the contents of physical memory to be written into a dump area, typically in the swap partition.

Upon a subsequent reboot, `savecore` is typically run out of rc(8), before swapping is enabled, to copy the kernel and the saved memory image into directory, and enters a reboot message and information about the core dump into the system log. If a directory is not specified, then /var/crash is used.

The kernel and core file can then be analyzed using various tools, including crash(8), dmesg(8), fstat(1), gdb(1), iostat(8), netstat(1), ps(1), and pstat(8), to attempt to deduce the cause of the crash.

Crashes are usually the result of hardware faults or kernel bugs. If a kernel bug is suspected, a full bug report should be filed at http://www.netbsd.org/, or using send-pr(1), containing as much information as possible about the circumstances of the crash. Since crash dumps are typically very large and may contain whatever (potentially confidential) information was in memory at the time of the crash, do NOT include a copy of the crash dump file in the bug report; instead, save it somewhere in the event that a NetBSD developer wants to examine it.

The options are as follows:

`-c`
  Only clears the dump without saving it, so that future invocations of `savecore` will ignore it.
`-f`
  Forces a dump to be taken even if the dump doesn't appear correct or there is insufficient disk space.
`-n`
  Check whether a dump is present without taking further action. The command exits with zero status if a dump is present, or with non-zero status otherwise.
`-N`
  Use system as the kernel instead of the default (returned by getbootfile(3)). Note that getbootfile(3) uses secure_path(3) to check that kernel file is “secure” and will default to /netbsd if the check fails.
`-v`
  Prints out some additional debugging information.
`-z`
  Compresses the core dump and kernel (see gzip(1)).
`-Z` level
  Set the compression level for `-z` to level. Defaults to 1 (the fastest compression mode). Refer to gzip(1) for more information regarding the compression level.

`savecore` checks the core dump in various ways to make sure that it is current and that it corresponds to the currently running system. If it passes these checks, it saves the core image in directory/netbsd.#.core and the system in directory/netbsd.# (or in directory/netbsd.#.core.gz and directory/netbsd.#.gz, respectively, if the `-z` option is used). The “#” is the number from the first line of the file directory/bounds, and it is incremented and stored back into the file each time `savecore` successfully runs.

`savecore` also checks the available disk space before attempting to make the copies. If there is insufficient disk space in the file system containing directory, or if the file directory/minfree exists and the number of free kilobytes (for non-superusers) in the file system after the copies were made would be less than the number in the first line of this file, the copies are not attempted.

If `savecore` successfully copies the kernel and the core dump, the core dump is cleared so that future invocations of `savecore` will ignore it.

# SEE ALSO

fstat(1), gdb(1), gzip(1), netstat(1), ps(1), send-pr(1), crash(8), dmesg(8), iostat(8), pstat(8), rc(8), syslogd(8), panic(9)

# HISTORY

The `savecore` command appeared in 4.1BSD.

# BUGS

The minfree code does not consider the effect of compression.

September 13, 2011 | NetBSD 10.1